<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Scoped CSS Variables and JS</title>
    <link rel="icon" href="https://fav.farm/🔥" />
  </head>
  <body>
    <h2>Update CSS Variables with <span class="hl">JS</span></h2>

    <div class="controls">
      <label for="spacing">Spacing:</label>
      <input
        id="spacing"
        type="range"
        name="spacing"
        min="10"
        max="200"
        value="10"
        data-sizing="px"
        data-name="custom-spacing"
      />

      <label for="blur">Blur:</label>
      <input
        id="blur"
        type="range"
        name="blur"
        min="0"
        max="25"
        value="10"
        data-sizing="px"
        data-name="custom-blur"
      />

      <label for="base">Base Color</label>
      <input id="base" type="color" name="base" value="#ffc600" data-name="custom-color" />
    </div>

    <img src="https://source.unsplash.com/7bwQXzbF6KE/800x500" />

    <style>
        /* created css variables (base, spacing, blur) */
        :root{
            --base: #ffc600;
            --spacing : 10px;
            /* --blur: 5px */
        }

        /* setting values(padding, background, filter) from variables */
        img{
            padding: var(--spacing);
            background: var(--base);
            filter: blur(var(--blur));
        }

      /*
      misc styles, nothing to do with CSS variables
    */

      body {
        text-align: center;
        background: #193549;
        color: white;
        font-family: "helvetica neue", sans-serif;
        font-weight: 100;
        font-size: 30px;
      }

      .controls {
        margin-bottom: 50px;
      }

      input {
        width: 100px;
      }
    </style>

    <script>
        // getting al input value
        const inputs = document.querySelectorAll(".controls input");
        // console.log(inputs);

        // function for handling values
        function handleUpdate(){
            // logs the dataset associated with that element( like 'custom-color')
            // console.log(this.dataset); 
            const suffix = this.dataset.sizing || '';
            // console.log(this.name,this.value, suffix);
            console.log(document.documentElement.
            style.setProperty(`--${this.name}`, `${this.value}${suffix}`));
        }    
        
        // added 2 EventListeners for change for changing the values & mousemove for getting the values when mouse is moving
        inputs.forEach(input => input.addEventListener('change', handleUpdate))
        inputs.forEach(input => input.addEventListener('mousemove', handleUpdate))

    </script>
  </body>
</html>
